Imports Inventor
Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Namespace Frderband
    <ProgIdAttribute("MyProject.StandardAddInServer"), _
    GuidAttribute("8176e5f7-53e9-45a6-92cd-7d4c32cc2a14")> _
    Public Class StandardAddInServer
        Implements Inventor.ApplicationAddInServer

        ' Inventor application object.
        Private m_inventorApplication As Inventor.Application


        Private Sub m_ButtonDef_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_ButtonDef.OnExecute

            Dim oForm As New InsertBoltForm                                 ' Stellt InsertBoltForm.vb als Objekt zur Verfgung

            oForm.Show()                                                    ' Zeigt InsertBoltForm.vb an

        End Sub

#Region "ApplicationAddInServer Members"

        Private WithEvents m_ButtonDef As ButtonDefinition

        Public Sub Activate(ByVal addInSiteObject As Inventor.ApplicationAddInSite, ByVal firstTime As Boolean) Implements _
                                                     Inventor.ApplicationAddInServer.Activate

            Dim m_ClientID As String
            Dim controlDefs As ControlDefinitions
            Dim Buttonimage As stdole.IPictureDisp
            Dim partCommandBar As Inventor.CommandBar

            ' This method is called by Inventor when it loads the AddIn.
            ' The AddInSiteObject provides access to the Inventor Application object.
            ' The FirstTime flag indicates if the AddIn is loaded for the first time.

            ' Initialize AddIn members.
            m_inventorApplication = addInSiteObject.Application

            ' Konvertiert die Grafik in den bentigten Typ
            Buttonimage = Microsoft.VisualBasic.Compatibility.VB6.ImageToIPictureDisp(My.Resources.pac)

            ' Liest die ClassID aus und bergibt sie an die Variable
            m_ClientID = AddInGuid(GetType(StandardAddInServer))

            ' Erzeugt die Button-Definition.
            controlDefs = m_inventorApplication.CommandManager.ControlDefinitions

            m_ButtonDef = controlDefs.AddButtonDefinition("Display Name", _
                                                          "Internal Name", _
                                                          CommandTypesEnum.kQueryOnlyCmdType, _
                                                          m_ClientID, _
                                                          "Description", _
                                                          "Tool Tip", _
                                                          Buttonimage)

            If firstTime Then
                ' Gibt die Position des Buttons an
                partCommandBar = m_inventorApplication.UserInterfaceManager.CommandBars.Item("AMxAssemblyPanelCmdBar")

                ' Erzeugt den Button in INV
                partCommandBar.Controls.AddButton(m_ButtonDef)

            End If
        End Sub

        Public Sub Deactivate() Implements Inventor.ApplicationAddInServer.Deactivate

            ' This method is called by Inventor when the AddIn is unloaded.
            ' The AddIn will be unloaded either manually by the user or
            ' when the Inventor session is terminated.

            ' TODO:  Add ApplicationAddInServer.Deactivate implementation

            ' Release objects.
            Marshal.ReleaseComObject(m_inventorApplication)
            m_inventorApplication = Nothing

            Marshal.ReleaseComObject(m_ButtonDef)
            m_ButtonDef = Nothing

            System.GC.WaitForPendingFinalizers()
            System.GC.Collect()

        End Sub

        Public ReadOnly Property Automation() As Object Implements Inventor.ApplicationAddInServer.Automation

            ' This property is provided to allow the AddIn to expose an API 
            ' of its own to other programs. Typically, this  would be done by
            ' implementing the AddIn's API interface in a class and returning 
            ' that class object through this property.

            Get
                Return Nothing
            End Get

        End Property

        Public Sub ExecuteCommand(ByVal commandID As Integer) Implements Inventor.ApplicationAddInServer.ExecuteCommand

            ' Note:this method is now obsolete, you should use the 
            ' ControlDefinition functionality for implementing commands.

        End Sub

#End Region

#Region "COM Registration"

        ' Registers this class as an AddIn for Inventor.
        ' This function is called when the assembly is registered for COM.
        <ComRegisterFunctionAttribute()> _
        Public Shared Sub Register(ByVal t As Type)

            Dim clssRoot As RegistryKey = Registry.ClassesRoot
            Dim clsid As RegistryKey = Nothing
            Dim subKey As RegistryKey = Nothing

            Try
                clsid = clssRoot.CreateSubKey("CLSID\" + AddInGuid(t))
                clsid.SetValue(Nothing, "MyProject-AddIn")                     ' Name des AddIn im Zusatzmodul-Manager
                subKey = clsid.CreateSubKey("Implemented Categories\{39AD2B5C-7A29-11D6-8E0A-0010B541CAA8}")
                subKey.Close()

                subKey = clsid.CreateSubKey("Settings")
                subKey.SetValue("AddInType", "Standard")
                subKey.SetValue("LoadOnStartUp", "1")

                'subKey.SetValue("SupportedSoftwareVersionLessThan", "")
                subKey.SetValue("SupportedSoftwareVersionGreaterThan", "14..")
                'subKey.SetValue("SupportedSoftwareVersionEqualTo", "")
                'subKey.SetValue("SupportedSoftwareVersionNotEqualTo", "")
                'subKey.SetValue("Hidden", "0")
                'subKey.SetValue("UserUnloadable", "1")
                subKey.SetValue("Version", 0.01)
                subKey.Close()

                subKey = clsid.CreateSubKey("Description")
                subKey.SetValue(Nothing, "MyProject")  ' Beschreibung des AddIn im Zusatzmodul-Manager

            Catch ex As Exception
                System.Diagnostics.Trace.Assert(False)
            Finally
                If Not subKey Is Nothing Then subKey.Close()
                If Not clsid Is Nothing Then clsid.Close()
                If Not clssRoot Is Nothing Then clssRoot.Close()
            End Try

        End Sub

        ' Unregisters this class as an AddIn for Inventor.
        ' This function is called when the assembly is unregistered.
        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub Unregister(ByVal t As Type)

            Dim clssRoot As RegistryKey = Registry.ClassesRoot
            Dim clsid As RegistryKey = Nothing

            Try
                clssRoot = Microsoft.Win32.Registry.ClassesRoot
                clsid = clssRoot.OpenSubKey("CLSID\" + AddInGuid(t), True)
                clsid.SetValue(Nothing, "")
                clsid.DeleteSubKeyTree("Implemented Categories\{39AD2B5C-7A29-11D6-8E0A-0010B541CAA8}")
                clsid.DeleteSubKeyTree("Settings")
                clsid.DeleteSubKeyTree("Description")
            Catch
            Finally
                If Not clsid Is Nothing Then clsid.Close()
                If Not clssRoot Is Nothing Then clssRoot.Close()
            End Try

        End Sub

        ' This property uses reflection to get the value for the GuidAttribute attached to the class.
        Public Shared ReadOnly Property AddInGuid(ByVal t As Type) As String
            Get
                Dim guid As String = ""
                Try
                    Dim customAttributes() As Object = t.GetCustomAttributes(GetType(GuidAttribute), False)
                    Dim guidAttribute As GuidAttribute = CType(customAttributes(0), GuidAttribute)
                    guid = "{" + guidAttribute.Value.ToString() + "}"
                Finally
                    AddInGuid = guid
                End Try
            End Get
        End Property

#End Region

    End Class

End Namespace







